#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "kohn_gif.h"
#include "fileio.h"

/**************************************************
 * Project: libkohn_gif
 *  Author: Michael A. Kohn
 *   Email: mike@mikekohn.net
 *     Web: http://www.mikekohn.net/
 * License: Copyright 2004-2009 under LGPL
 **************************************************/

int main(int argc, char *argv[])
{
/* FILE *out,*in; */
struct gif_info_t *input_gif;
int x,y;
int num_bytes,ptr;
//                            0123456789abcdef
const char output_colors[16]="#@&%*=+!1/~-_,. ";
int t,v,c;

  printf("\ngif2ascii\n");
  printf("Copyright 2004-2007 - Michael Kohn <mike@mikekohn.net>\n");
  printf("Version Date: September 9, 2007\n\n");

  if (argc!=2)
  {
    printf("Usage: gif2ascii <input file>\n");
    exit(0);
  }

  input_gif=kgif_alloc_decompress();

  input_gif->fp=fopen(argv[1],"rb");
  if (input_gif->fp==0)
  {
    printf("Couldn't open input file.\n");
    exit(1);
  }

  if (kgif_read_header(input_gif)!=0)
  {
    printf("Input file is not a valid GIF.\n");
    fclose(input_gif->fp);
    exit(1);
  }

  printf("Opening a GIF of size %d x %d\n",input_gif->width,input_gif->height);

  /* Now for the real decompression and compression stuff */

  ptr=0;
  x=0;
  y=0;

  for (t=0; t<input_gif->colors; t++)
  {
    printf("%06x\n",input_gif->color_map[t]);
  }

  while(y<input_gif->height)
  {
    if (input_gif->y>y)
    { break; }

    num_bytes=kgif_decompress(input_gif);

    for (t=0; t<num_bytes; t++)
    {
      v=input_gif->decomp_buff[t];
      v=input_gif->color_map[v];
      c=((v>>16)+((v>>8)&255)+(v&255))/3;
      c=c>>4;
      if (c>15) c=15;
        else
      if (c<0) v=0;
      printf("%c",output_colors[c]);

/*
      if (c<10)
      { printf("%c",c+'0'); }
        else
      { printf("%c",c+'a'-10); }
*/

      x++;
      if (x>=input_gif->width)
      {
        printf("\n");
        x=0;
        y++;
      }
    }
  }

  fclose(input_gif->fp);
  kgif_info_free(input_gif);

  return 0;
}



