#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "kohn_gif.h"
#include "fileio.h"

/**************************************************
 * Project: libkohn_gif
 *  Author: Michael A. Kohn
 *   Email: mike@mikekohn.net
 *     Web: http://www.mikekohn.net/
 * License: Copyright 2004-2009 under LGPL
 **************************************************/

int main(int argc, char *argv[])
{
/* FILE *out,*in; */
FILE *out;
struct gif_info_t *input_gif;
int x,y;
int num_bytes,ptr;
//                            0123456789abcdef
int t,v;
char *text=0;
int text_ptr;

  printf("\ngif2html\n");
  printf("Copyright 2004-2007 - Michael Kohn <mike@mikekohn.net>\n");
  printf("Version Date: September 9, 2007\n\n");

  if (argc<3 || argc>4)
  {
    printf("Usage: gif2html <input.gif> <output.html> <optional: text>\n");
    exit(0);
  }

  input_gif=kgif_alloc_decompress();

  input_gif->fp=fopen(argv[1],"rb");
  if (input_gif->fp==0)
  {
    printf("Couldn't open input file.\n");
    exit(1);
  }

  out=fopen(argv[2],"wb");
  if (out==0)
  {
    printf("Could not open output file\n");
    fclose(input_gif->fp);
    exit(1);
  }

  if (argc==4)
  {
    text=argv[3];
  }

  if (kgif_read_header(input_gif)!=0)
  {
    printf("Input file is not a valid GIF.\n");
    fclose(input_gif->fp);
    kgif_info_free(input_gif);
    exit(1);
  }

  printf("Opening a GIF of size %d x %d\n",input_gif->width,input_gif->height);

  /* Now for the real decompression and compression stuff */

  text_ptr=0;

  ptr=0;
  x=0;
  y=0;

/*
  for (t=0; t<input_gif->colors; t++)
  {
    printf("%06x\n",input_gif->color_map[t]);
  }
*/

  fprintf(out,"<html>\n");
  fprintf(out,"<body>\n");
  fprintf(out,"<table cellspacing=0 cellpadding=0>\n");

  while(y<input_gif->height)
  {
    if (input_gif->y>y)
    { break; }

    num_bytes=kgif_decompress(input_gif);

    for (t=0; t<num_bytes; t++)
    {
      v=input_gif->decomp_buff[t];
      v=input_gif->color_map[v];

/*
      c=((v>>16)+((v>>8)&255)+(v&255))/3;
      c=c>>4;

      if (c>15) c=15;
        else
      if (c<0) v=0;
*/

      if (x==0) fprintf(out,"<tr>");

      if (text!=0)
      {
        fprintf(out,"<td width=6 bgcolor='#%06x'>%c</td>",v,text[text_ptr]);
        text_ptr++;
        if (text[text_ptr]==0) text_ptr=0;
      }
        else
      {
        fprintf(out,"<td width=6 bgcolor='#%06x'>&nbsp;</td>",v);
      }

/*
      if (c<10)
      { printf("%c",c+'0'); }
        else
      { printf("%c",c+'a'-10); }
*/

      x++;
      if (x>=input_gif->width)
      {
        fprintf(out,"</tr>\n");
        x=0;
        y++;
      }
    }
  }

  if (x!=0) fprintf(out,"</tr>\n");

  fprintf(out,"</table>\n");
  fprintf(out,"</body>\n");
  fprintf(out,"</html>\n");

  fclose(input_gif->fp);
  kgif_info_free(input_gif);

  return 0;
}



