/**************************************************
 * Project: libkohn_gif
 *  Author: Michael A. Kohn
 *   Email: mike@mikekohn.net
 *     Web: http://www.mikekohn.net/
 * License: Copyright 2004-2009 under LGPL
 **************************************************/

/* #define BUFFER_SIZE 8192 */
#define DECOMP_BUFFER_SIZE 4096

struct decompress_node_t
{
  int prev;
  unsigned char color;
};

struct compress_node_t
{
  int down;
  int right;
  unsigned char color;
};

struct gif_info_t
{
  FILE *fp;
  int version;
  unsigned int width;
  unsigned int height;
  unsigned int colors;
  unsigned int color_map[256];
  unsigned char bw_color_map[256];
  unsigned char resolution;
  unsigned char bgcolor;
  unsigned char aspect;
  unsigned char flags;
  int code_size;
  int curr_code_size;
  int start_table_size;
  int data_count;
  unsigned int holding;
  int bitptr;
  int clear_code;
  int eof_code;
  int mask;
  int code;
  int old_code;
  int next_code;
  int status;
  int x,y;
  int full_image_size;
  int count,ptr;
  unsigned char *decomp_buff;
  struct decompress_node_t *dnode;
  struct compress_node_t *cnode;
  /* gif89a stuff */
  int transparency_index; /* set to -1 for no trans or 0-255 for palette index*/
};

/* Decompressor Stuff */

struct gif_info_t *kgif_alloc_decompress();
int kgif_read_header(struct gif_info_t *gif_info);
int kgif_decompress_block(struct gif_info_t *gif_info);

/* Compressor Stuff */

struct gif_info_t *kgif_alloc_compress();
int kgif_write_header(struct gif_info_t *gif_info);
int kgif_compress_block(struct gif_info_t *gif_info, unsigned char *uncomp_data, int len);
int kgif_write_footer(struct gif_info_t *gif_info);

/* General */

int kgif_info_free(struct gif_info_t *gif_info);
int kgif_info_reset(struct gif_info_t *gif_info);

const char *kgif_version_string();


